## llvm-toolchain-19 19.1.0~++rc3

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.0~++rc3-1~exp2ubuntu5) oracular; urgency=medium

  * Add a .gitignore file with all toplevel upstream files and directories.
  * Add some memory tracking, getting some information on memory hogs.
  * Don't require g++-multilib on s390x for newer Ubuntu releases.
  * Factor-out ocaml architectures.
  * Don't try to install xray and profile headers on armel and armhf.
  * Disable ocaml on armhf, requires ocamlopt.
  * Factor-out omp architectures.
  * Disable openmp on riscv64 (ld: cannot find -lomptarget.rtl.host).
  * Factor-out flang architectures.
  * Disable flang on mips64el (currently not supported).
  * Don't try to install hwasan_symbolize on x32.
  * Don't try to install xray and profile headers on x32.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 27 Aug 2024 14:46:25 +0200

llvm-toolchain-19 (1:19.1.0~++rc3-1~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * ld.lld: When no package-metadata option is given, fall-back
    to the envvar ELF_PACKAGE_METADATA.

  [ Emanuele Rocca ]
  * Enable bolt on arm64, now supported upstream.

  [ Sylvestre Ledru ]
  * remove llvm-cgdata - see 9e90c40564e21dc5f1a12e08cfdf29305aaf9f50
  * New snapshot release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 20 Aug 2024 19:52:02 +0200
