## llvm-toolchain-19 19.1.0~++rc4

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.0~++rc4-2) unstable; urgency=medium

  * Disable z3 again for Ubuntu, and make the libz3-dev (build) dependency
    conditional.
  * Use -mxgot on mips64el.
  * Disable tests on mips64el, they do timeout.

 -- Matthias Klose <doko@debian.org>  Wed, 04 Sep 2024 15:16:40 +0200

llvm-toolchain-19 (1:19.1.0~++rc4-1) unstable; urgency=medium

  * New release candidate.

  [ Matthias Klose ]
  * Also explicitly link with -latomic on mips64el.
  * Disable openmp on loong64 (ld: cannot find -lomptarget.rtl.host).
  * Build without z3 on sh4 (ftbfs).
  * Also configure with -DLLVM_EXPERIMENTAL_TARGETS_TO_BUILD="M68k;Xtensa".
  * debian/tests/*: s/18/19/.
  * debian/qualify-clang.sh: Don't check for libclang-cpp.so.$VERSION symlink.
  * libllvm19: Restore the symlink /usr/lib/llvm-19/lib/libLLVM.so.1, apparently
    CMake's LLVMExports.cmake requires it. But why?

  [ Samuel Thibault ]
  * Add hurd-amd64 support.

  [ Sylvestre Ledru ]
  * Remove the cmake dependency on libLibcTableGenUtil.a
    see https://github.com/llvm/llvm-project/issues/99819
  * New snapshot release

 -- Matthias Klose <doko@debian.org>  Tue, 03 Sep 2024 21:48:12 +0200

llvm-toolchain-19 (1:19.1.0~++rc3-2) unstable; urgency=medium

  * Fix binary-indep build.
  * Disable openmp on mips64el (ld: cannot find -lomptarget.rtl.host).
  * Disable memory tracking on the Hurd and some ports architectures.

 -- Matthias Klose <doko@debian.org>  Sat, 31 Aug 2024 08:10:14 +0200

llvm-toolchain-19 (1:19.1.0~++rc3-1) unstable; urgency=medium

  * Add a .gitignore file with all toplevel upstream files and directories.
  * Add some memory tracking, getting some information on memory hogs.
  * Don't require g++-multilib on s390x for newer Ubuntu releases.
  * Factor-out ocaml architectures.
  * Don't try to install xray and profile headers on armel and armhf.
  * Disable ocaml on armhf, requires ocamlopt.
  * Factor-out omp architectures.
  * Disable openmp on riscv64 (ld: cannot find -lomptarget.rtl.host).
  * Factor-out flang architectures.
  * Disable flang on mips64el (currently not supported).
  * Don't try to install hwasan_symbolize on x32.
  * Don't try to install xray and profile headers on x32.
  * Fix installation of the shared libllvm and libclang-cpp libraries
    under their soname. Closes: #1072200.
  * Drop some of the unnecessary libllvm symlinks.
  * debian/orig-tar.sh: Don't include .git/.github metadata.
  * debian/rules. Call again dh_ocaml. Closes: #1078234.
  * debian/rules: Don't create a stamp for the override_dh_auto_install target.

 -- Matthias Klose <doko@debian.org>  Fri, 30 Aug 2024 19:32:59 +0200
