=== debian/control ===
--- 
+++ 
@@ -16,14 +16,14 @@
     libipt-dev [amd64 i386],
     lcov, procps, help2man,
     zlib1g-dev, libzstd-dev,
-    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 sparc sparc64 x32],
+    g++-multilib [amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32],
     libjs-mathjax, python3-myst-parser | python3-recommonmark, python3-pexpect,
-    doxygen, python3:any, python3-psutil, python3-matplotlib [!i386],
+    doxygen, python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
     ocaml-base [amd64 arm64 ppc64el riscv64 s390x] | ocaml-nox [amd64 arm64 ppc64el riscv64 s390x],
     ocaml-findlib [amd64 arm64 ppc64el riscv64 s390x],
     libctypes-ocaml-dev [amd64 arm64 ppc64el riscv64 s390x],
     dh-exec, dh-ocaml [amd64 arm64 ppc64el riscv64 s390x],
-    libpfm4-dev [linux-any], python3-setuptools, libz3-dev,
+    libpfm4-dev [linux-any], python3-setuptools, libz3-dev [!sh4],
 # "| hello" is for older buster/bionic distros without spirv support
 # We need to keep the constraints coherent between the two alternatives, otherwise
 # hello would get installed unexpectedly and prevent e.g. wasi-libc from getting pulled
@@ -291,5 +291,3 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, clang-19 (= ${binary:Version})
 Description: Library for coverage-guided fuzz testing
  LibFuzzer is a library for in-process, coverage-guided, evolutionary fuzzing
- of other libraries.
- .
