=== debian/rules ===
--- 
+++ 
@@ -94,7 +94,13 @@
       SUMMARY_ONLY = --summary-only
     endif
   else
-    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib,
+    USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
+    ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
+      TIME_COMMAND = /bin/time -v
+    endif
+    ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32))
+      SUMMARY_ONLY = --summary-only
+    endif
   endif
 endif
 
@@ -176,7 +182,7 @@
 STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
 endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel powerpc powerpcspe riscv64))
+ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel mips64el powerpc powerpcspe riscv64))
 # For some reason, in the stage2 build, when clang is used to compile
 # itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
 # everywhere and in all stages
@@ -184,16 +190,5 @@
 endif
 
 Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
-ifeq ($(shell dpkg --compare-versions $(shell dpkg-query -W -f '$${Version}' libz3-dev) gt 4.7.0; echo $$?),0)
 # no ocaml support in main for Ubuntu
-ifeq ($(DERIVATIVE),Debian)
-	Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=ON
-endif
-endif
-STAGE_2_CMAKE_EXTRA += $(Z3_FLAG)
-
-# Change the default CPU for s390x
-ZARCH=z196
-ifeq ($(DERIVATIVE),Ubuntu)
-ZARCH=z13
-endif
+ifneq ($(DERIVATIVE),Ubuntu)
