## llvm-toolchain-19 19.1.0

=== debian/changelog ===
llvm-toolchain-19 (1:19.1.0-1ubuntu1) oracular; urgency=medium

  * Regenerate the control file.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Sep 2024 19:41:19 +0200

llvm-toolchain-19 (1:19.1.0-1) unstable; urgency=medium

  * New upstream release 19.1.0.

  [ Matthias Klose ]
  * debian/qualify-clang.sh: Skip llvmlibc test, if libllvmlibc-dev is not
    available.
  * Build-depend on llvm-spirv-19.

  [ YunQiang Su ]
  * also pass -mxgot in LDFLAGS.
  * d/p/mips-mlir-xgot.diff: Pass -mxgot for mlir.

 -- Matthias Klose <doko@debian.org>  Tue, 17 Sep 2024 18:04:21 +0200

llvm-toolchain-19 (1:19.1.0~++rc4-5) unstable; urgency=medium

  * Move the libLLVM.so.1 symlink into llvm-19-dev. Closes: #1081192.

 -- Matthias Klose <doko@debian.org>  Mon, 09 Sep 2024 11:20:16 +0200

llvm-toolchain-19 (1:19.1.0~++rc4-4) unstable; urgency=medium

  [ Matthias Klose ]
  * Consolidate disabling CMake's package validation checks a bit.
  * debian/qualify-clang.sh: Skip OpenMP test, if libomp-dev is not available.
  * Disable CMake's package validation check for libLLVM.so.1.
  * Limit lldb autopkg test to the lldb architectures.
  * Generate debian/tests/* files.
  * Disable the usage-wrapper/memory tracking by default.
  * Replace LLDB_DISABLE_ARCHS macro with LLDB_ARCHS macro.
  * Remove unused kfreebsd patches, and remove references to kfreebsd and s390.
  * Remove references to alpha, hppa, powerpcspe and sh4.
  * Fix usage-wrapper build dependency.

  [ Aurelien Jarno ]
  * Enable lldb on riscv64.
  * Enable lldb autopkgtest on riscv64.

 -- Matthias Klose <doko@debian.org>  Sun, 08 Sep 2024 17:36:43 +0200
