=== debian/rules ===
--- 
+++ 
@@ -72,7 +72,7 @@
 packages := $(shell dh_listpackages)
 
 # no 32bit support
-FLANG_ARCHS := amd64 arm64 ppc64el kfreebsd-amd64 ppc64 sparc64 riscv64 loong64
+FLANG_ARCHS := amd64 arm64 ppc64el ppc64 sparc64 riscv64 loong64
 
 # flang has some memory hogs, of up to 6.2gb per process. Limit the parallel jobs
 # based on the available memory
@@ -85,8 +85,10 @@
 		awk -vn=$(NCPUS) -vmt=$$mt -vm=$(MEM_PER_CPU) \
 		  'END { mt/=1024; n2 = int(mt/m); print n==1 ? 1 : n2<n+1 ? n2 : n+1}' < /dev/null)
 
-TIME_COMMAND = /bin/time -v
 TIME_COMMAND = $(CURDIR)/debian/usage-wrapper.py $(SUMMARY_ONLY) -j $(NJOBS) --base-memory -m 4.0 -o usage-$(notdir $@)-$(DEB_HOST_ARCH).svg
+TIME_BIN := $(if $(wildcard /usr/bin/time),/usr/bin/time,/bin/time)
+TIME_COMMAND = $(TIME_BIN) -v
+USAGE_BUILD_DEP = $(EMPTY) time,
 ifneq (,$(findstring usage-wrapper, $(TIME_COMMAND)))
   ifeq ($(DERIVATIVE),Ubuntu)
     USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil, python3-matplotlib [!i386],
@@ -96,7 +98,7 @@
   else
     USAGE_BUILD_DEP = $(EMPTY) python3:any, python3-psutil [!hurd-i386 !hurd-amd64], python3-matplotlib [!m68k !sh4 !x32 !hurd-i386 !hurd-amd64],
     ifneq (,$(filter $(DEB_HOST_ARCH), hurd-i386 hurd-amd64))
-      TIME_COMMAND = /bin/time -v
+      TIME_COMMAND = $(TIME_BIN) -v
     endif
     ifneq (,$(filter $(DEB_HOST_ARCH), m68k sh4 x32))
       SUMMARY_ONLY = --summary-only
@@ -108,10 +110,10 @@
 
 include /usr/share/dpkg/architecture.mk
 
-MULTILIB_ARCHS := amd64 i386 kfreebsd-amd64 mips64 mips64el mipsel powerpc ppc64 s390 s390x sparc sparc64 x32
+MULTILIB_ARCHS := amd64 i386 mips64 mips64el mipsel powerpc ppc64 s390x sparc sparc64 x32
 ifeq ($(DERIVATIVE),Ubuntu)
   ifeq (,$(filter $(DISTRO), bionic focal jammy noble))
-    MULTILIB_ARCHS := $(filter-out s390 s390x, $(MULTILIB_ARCHS))
+    MULTILIB_ARCHS := $(filter-out s390x, $(MULTILIB_ARCHS))
   endif
 endif
 
@@ -182,7 +184,7 @@
 STAGE_1_CMAKE_EXTRA += -DLLVM_PARALLEL_LINK_JOBS=4
 endif
 
-ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 kfreebsd-i386 armel mipsel mips64el powerpc powerpcspe riscv64))
+ifneq (,$(filter $(DEB_HOST_ARCH),i386 hurd-i386 armel mipsel mips64el powerpc riscv64))
 # For some reason, in the stage2 build, when clang is used to compile
 # itself. The atomic detection is failing on armel and riscv64. Forcing the inclusion
 # everywhere and in all stages
@@ -191,4 +193,3 @@
 
 Z3_FLAG = -DLLVM_ENABLE_Z3_SOLVER=OFF
 # no ocaml support in main for Ubuntu
-ifneq ($(DERIVATIVE),Ubuntu)
